// This code was autogenerated with `dbus-codegen-rust build.rs`, see https://github.com/diwic/dbus-rs
use dbus as dbus;
use dbus::arg;
use dbus::tree;

pub trait OrgFreedesktopNetworkManagerSecretAgent {
    fn get_secrets(&self, connection: ::std::collections::HashMap<&str, ::std::collections::HashMap<&str, arg::Variant<Box<dyn arg::RefArg>>>>, connection_path: dbus::Path, setting_name: &str, hints: Vec<&str>, flags: u32) -> Result<::std::collections::HashMap<String, ::std::collections::HashMap<String, arg::Variant<Box<dyn arg::RefArg + 'static>>>>, tree::MethodErr>;
    fn cancel_get_secrets(&self, connection_path: dbus::Path, setting_name: &str) -> Result<(), tree::MethodErr>;
    fn save_secrets(&self, connection: ::std::collections::HashMap<&str, ::std::collections::HashMap<&str, arg::Variant<Box<dyn arg::RefArg>>>>, connection_path: dbus::Path) -> Result<(), tree::MethodErr>;
    fn delete_secrets(&self, connection: ::std::collections::HashMap<&str, ::std::collections::HashMap<&str, arg::Variant<Box<dyn arg::RefArg>>>>, connection_path: dbus::Path) -> Result<(), tree::MethodErr>;
}

pub fn org_freedesktop_network_manager_secret_agent_server<F, T, D>(factory: &tree::Factory<tree::MTFn<D>, D>, data: D::Interface, f: F) -> tree::Interface<tree::MTFn<D>, D>
where
    D: tree::DataType,
    D::Method: Default,
    T: OrgFreedesktopNetworkManagerSecretAgent,
    F: 'static + for <'z> Fn(& 'z tree::MethodInfo<tree::MTFn<D>, D>) -> & 'z T,
{
    let i = factory.interface("org.freedesktop.NetworkManager.SecretAgent", data);
    let f = ::std::sync::Arc::new(f);
    let fclone = f.clone();
    let h = move |minfo: &tree::MethodInfo<tree::MTFn<D>, D>| {
        let mut i = minfo.msg.iter_init();
        let connection: ::std::collections::HashMap<&str, ::std::collections::HashMap<&str, arg::Variant<Box<dyn arg::RefArg>>>> = i.read()?;
        let connection_path: dbus::Path = i.read()?;
        let setting_name: &str = i.read()?;
        let hints: Vec<&str> = i.read()?;
        let flags: u32 = i.read()?;
        let d = fclone(minfo);
        let secrets = d.get_secrets(connection, connection_path, setting_name, hints, flags)?;
        let rm = minfo.msg.method_return();
        let rm = rm.append1(secrets);
        Ok(vec!(rm))
    };
    let m = factory.method("GetSecrets", Default::default(), h);
    let m = m.in_arg(("connection", "a{sa{sv}}"));
    let m = m.in_arg(("connection_path", "o"));
    let m = m.in_arg(("setting_name", "s"));
    let m = m.in_arg(("hints", "as"));
    let m = m.in_arg(("flags", "u"));
    let m = m.out_arg(("secrets", "a{sa{sv}}"));
    let i = i.add_m(m);

    let fclone = f.clone();
    let h = move |minfo: &tree::MethodInfo<tree::MTFn<D>, D>| {
        let mut i = minfo.msg.iter_init();
        let connection_path: dbus::Path = i.read()?;
        let setting_name: &str = i.read()?;
        let d = fclone(minfo);
        d.cancel_get_secrets(connection_path, setting_name)?;
        let rm = minfo.msg.method_return();
        Ok(vec!(rm))
    };
    let m = factory.method("CancelGetSecrets", Default::default(), h);
    let m = m.in_arg(("connection_path", "o"));
    let m = m.in_arg(("setting_name", "s"));
    let i = i.add_m(m);

    let fclone = f.clone();
    let h = move |minfo: &tree::MethodInfo<tree::MTFn<D>, D>| {
        let mut i = minfo.msg.iter_init();
        let connection: ::std::collections::HashMap<&str, ::std::collections::HashMap<&str, arg::Variant<Box<dyn arg::RefArg>>>> = i.read()?;
        let connection_path: dbus::Path = i.read()?;
        let d = fclone(minfo);
        d.save_secrets(connection, connection_path)?;
        let rm = minfo.msg.method_return();
        Ok(vec!(rm))
    };
    let m = factory.method("SaveSecrets", Default::default(), h);
    let m = m.in_arg(("connection", "a{sa{sv}}"));
    let m = m.in_arg(("connection_path", "o"));
    let i = i.add_m(m);

    let fclone = f.clone();
    let h = move |minfo: &tree::MethodInfo<tree::MTFn<D>, D>| {
        let mut i = minfo.msg.iter_init();
        let connection: ::std::collections::HashMap<&str, ::std::collections::HashMap<&str, arg::Variant<Box<dyn arg::RefArg>>>> = i.read()?;
        let connection_path: dbus::Path = i.read()?;
        let d = fclone(minfo);
        d.delete_secrets(connection, connection_path)?;
        let rm = minfo.msg.method_return();
        Ok(vec!(rm))
    };
    let m = factory.method("DeleteSecrets", Default::default(), h);
    let m = m.in_arg(("connection", "a{sa{sv}}"));
    let m = m.in_arg(("connection_path", "o"));
    let i = i.add_m(m);
    i
}
